package jp.hishidama.swing.undo;

import javax.swing.event.UndoableEditListener;
import javax.swing.undo.UndoManager;
import javax.swing.undo.UndoableEdit;
import javax.swing.undo.UndoableEditSupport;

/**
 * gUndoableEditSupport.
 * <ul>
 * <li>UNDOʒm@\</li>
 * </ul>
 *
 * @author <a target="hishidama" href=
 *         "http://www.ne.jp/asahi/hishidama/home/tech/soft/java/swing/UndoManager.html"
 *         >Ђ</a>
 * @since 2009.04.26
 */
public class ExUndoableEditSupport extends UndoableEditSupport {

	/** RXgN^[. */
	public ExUndoableEditSupport() {
		super();
	}

	/**
	 * RXgN^[.
	 *
	 * @param r
	 *            IuWFNg
	 */
	public ExUndoableEditSupport(Object r) {
		super(r);
	}

	protected int ignoreLevel = 0;

	/**
	 * UNDOʒm̊Jn.
	 */
	public synchronized void beginIgnore() {
		ignoreLevel++;
	}

	/**
	 * UNDOʒm̏I.
	 */
	public synchronized void endIgnore() {
		ignoreLevel--;
	}

	/**
	 * UNDOʒmǂԂ.
	 *
	 * @return ʒm̏ꍇAtrue
	 */
	public boolean isIgnore() {
		return ignoreLevel > 0;
	}

	/**
	 * UNDȌꍇAʒm͍sȂB
	 *
	 * @see #beginIgnore()
	 */
	@Override
	protected void _postEdit(UndoableEdit e) {
		if (ignoreLevel == 0) {
			super._postEdit(e);
		}
	}

	/**
	 * UNDO}l[W[ɂ.
	 * <p>
	 * o^Ă郊Xi[UndoManager̂ƂAdiscardAllEdits()ĂяoB
	 * </p>
	 *
	 * @see UndoManager#discardAllEdits()
	 */
	public void discardAllEdits() {
		for (UndoableEditListener l : listeners) {
			if (l instanceof UndoManager) {
				UndoManager um = (UndoManager) l;
				um.discardAllEdits();
			}
		}
	}
}
